package blusunrize.immersiveengineering.common.blocks.metal;

import blusunrize.immersiveengineering.common.Config.IEConfig;
import blusunrize.immersiveengineering.common.IEContent;
import blusunrize.immersiveengineering.common.blocks.BlockTypes_MetalsAll;
import blusunrize.immersiveengineering.common.blocks.IEBlockInterfaces.IComparatorOverride;
import blusunrize.immersiveengineering.common.blocks.TileEntityMultiblockPart;
import blusunrize.immersiveengineering.common.blocks.wooden.BlockTypes_WoodenDecoration;
import blusunrize.immersiveengineering.common.util.Utils;
import net.minecraft.block.Block;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumFacing.Axis;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.common.capabilities.Capability;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.FluidTank;
import net.minecraftforge.fluids.IFluidTank;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.items.CapabilityItemHandler;
import net.minecraftforge.items.IItemHandler;
import net.minecraftforge.items.IItemHandlerModifiable;
import net.minecraftforge.items.ItemHandlerHelper;

public class TileEntitySilo extends TileEntityMultiblockPart<TileEntitySilo> implements IComparatorOverride //IDeepStorageUnit
{
	public ItemStack identStack;
	public int storageAmount = 0;
	static int maxStorage = 41472;
	//	ItemStack inputStack;
//	ItemStack outputStack;
//	ItemStack prevInputStack;
//	ItemStack prevOutputStack;
	boolean lockItem = false;
	private int[] oldComps = new int[6];
	private int masterCompOld;
	private boolean forceUpdate = false;

	@Override
	public void func_73660_a()
	{
//		if(pos==4 && !worldObj.isRemote && this.outputStack==null && storageAmount>0 && identStack!=null)
//			this.markDirty();

		if(pos==4 && !field_145850_b.field_72995_K && this.identStack!=null && storageAmount>0 && field_145850_b.func_175687_A(func_174877_v())>0 && field_145850_b.func_82737_E()%8==0)
		{
			updateComparatorValuesPart1();
			for(EnumFacing f : EnumFacing.values())
				if(f!=EnumFacing.UP)
				{
					TileEntity inventory = this.field_145850_b.func_175625_s(func_174877_v().func_177972_a(f));
					ItemStack stack = Utils.copyStackWithAmount(identStack,1);
					stack = Utils.insertStackIntoInventory(inventory, stack, f.func_176734_d());
					if(stack==null)
					{
						storageAmount--;
						if(storageAmount<=0)
							identStack = null;
						this.func_70296_d();
						markContainingBlockForUpdate(null);
						if(storageAmount<=0)
							break;
					}
				}
			updateComparatorValuesPart2();
		}
	}

	@Override
	public void readCustomNBT(NBTTagCompound nbt, boolean descPacket)
	{
		super.readCustomNBT(nbt, descPacket);
		if(nbt.func_74764_b("identStack"))
		{
			NBTTagCompound t = nbt.func_74775_l("identStack");
			this.identStack = ItemStack.func_77949_a(t);
		}
		else
			this.identStack = null;
		storageAmount = nbt.func_74762_e("storageAmount");
		lockItem = nbt.func_74767_n("lockItem");
	}

	@Override
	public void writeCustomNBT(NBTTagCompound nbt, boolean descPacket)
	{
		super.writeCustomNBT(nbt, descPacket);
		if(this.identStack!=null)
		{
			NBTTagCompound t = this.identStack.func_77955_b(new NBTTagCompound());
			nbt.func_74782_a("identStack", t);
		}
		nbt.func_74768_a("storageAmount", storageAmount);
		nbt.func_74757_a("lockItem", lockItem);
	}

	@Override
	protected IFluidTank[] getAccessibleFluidTanks(EnumFacing side)
	{
		return new FluidTank[0];
	}
	@Override
	protected boolean canFillTankFrom(int iTank, EnumFacing side, FluidStack resources)
	{
		return false;
	}
	@Override
	protected boolean canDrainTankFrom(int iTank, EnumFacing side)
	{
		return false;
	}

	@Override
	public float[] getBlockBounds()
	{
		if(pos==0||pos==2||pos==6||pos==8)
		{
			float xMin = (facing.func_176740_k() == Axis.X ? (pos > 2 ^ facing == EnumFacing.EAST) : (pos % 3 == 2 ^ facing == EnumFacing.SOUTH)) ? .75f : 0;
			float xMax = (facing.func_176740_k() == Axis.X ? (pos < 3 ^ facing == EnumFacing.EAST) : (pos % 3 == 0 ^ facing == EnumFacing.SOUTH)) ? .25f : 1;
			float zMin = (facing.func_176740_k() == Axis.X ? (pos % 3 == 2 ^ facing == EnumFacing.EAST) : (pos < 3 ^ facing == EnumFacing.SOUTH)) ? .75f : 0;
			float zMax = (facing.func_176740_k() == Axis.X ? (pos % 3 == 0 ^ facing == EnumFacing.EAST) : (pos > 2 ^ facing == EnumFacing.SOUTH)) ? .25f : 1;
			return new float[]{xMin, 0, zMin, xMax, 1, zMax};
		}
		return new float[]{0,0,0,1,1,1};
	}

	@Override
	public ItemStack getOriginalBlock()
	{
		return pos==0||pos==2||pos==6||pos==8?new ItemStack(IEContent.blockWoodenDecoration,1,BlockTypes_WoodenDecoration.FENCE.getMeta()):new ItemStack(IEContent.blockSheetmetal,1,BlockTypes_MetalsAll.IRON.getMeta());
	}

	@Override
	public void disassemble()
	{
		super.func_145843_s();
		if(formed && !field_145850_b.field_72995_K)
		{
			BlockPos startPos = this.func_174877_v().func_177982_a(-offset[0],-offset[1],-offset[2]);
			if(!(offset[0]==0&&offset[1]==0&&offset[2]==0) && !(field_145850_b.func_175625_s(startPos) instanceof TileEntitySilo))
				return;

			for(int yy=0;yy<=6;yy++)
				for(int xx=-1;xx<=1;xx++)
					for(int zz=-1;zz<=1;zz++)
					{
						ItemStack s = null;
						TileEntity te = field_145850_b.func_175625_s(startPos.func_177982_a(xx, yy, zz));
						if(te instanceof TileEntitySilo)
						{
							s = ((TileEntitySilo)te).getOriginalBlock();
							((TileEntitySilo)te).formed=false;
						}
						if(startPos.func_177982_a(xx, yy, zz).equals(func_174877_v()))
							s = this.getOriginalBlock();
						if(s!=null && Block.func_149634_a(s.func_77973_b())!=null)
						{
							if(startPos.func_177982_a(xx, yy, zz).equals(func_174877_v()))
								field_145850_b.func_72838_d(new EntityItem(field_145850_b, func_174877_v().func_177958_n()+.5,func_174877_v().func_177956_o()+.5,func_174877_v().func_177952_p()+.5, s));
							else
							{
								if(Block.func_149634_a(s.func_77973_b())==IEContent.blockMetalMultiblock)
									field_145850_b.func_175698_g(startPos.func_177982_a(xx, yy, zz));
								field_145850_b.func_175656_a(startPos.func_177982_a(xx, yy, zz), Block.func_149634_a(s.func_77973_b()).func_176203_a(s.func_77952_i()));
							}
						}
					}
		}
	}

	@SideOnly(Side.CLIENT)
	private AxisAlignedBB renderAABB;
	@Override
	@SideOnly(Side.CLIENT)
	public AxisAlignedBB getRenderBoundingBox()
	{
		if(renderAABB==null)
			if(pos==4)
				renderAABB = new AxisAlignedBB(func_174877_v().func_177982_a(-1,0,-1), func_174877_v().func_177982_a(2,7,2));
			else
				renderAABB = new AxisAlignedBB(func_174877_v(),func_174877_v());
		return renderAABB;
	}
	@Override
	@SideOnly(Side.CLIENT)
	public double func_145833_n()
	{
		return super.func_145833_n()* IEConfig.increasedTileRenderdistance;
	}

	/*
	//DEEP STORAGE
	@Override
	public ItemStack getStoredItemType()
	{
		TileEntitySilo mast = master();
		if (mast!=null)
			return mast.getStoredItemType();
		if(this.identStack != null)
			return Utils.copyStackWithAmount(identStack, storageAmount);
		return null;
	}

	@Override
	public void setStoredItemCount(int amount)
	{
		TileEntitySilo mast = master();
		if (mast!=null)
		{
			mast.setStoredItemCount(amount);
			return;
		}
		updateComparatorValuesPart1();
		if(amount > maxStorage)
			amount = maxStorage;
		this.storageAmount = amount;
		this.forceUpdate = true;
		this.markDirty();
		updateComparatorValuesPart2();
	}

	@Override
	public void setStoredItemType(ItemStack type, int amount)
	{
		TileEntitySilo mast = master();
		if (mast!=null)
		{
			mast.setStoredItemType(type, amount);
			return;
		}
		updateComparatorValuesPart1();
		this.identStack = Utils.copyStackWithAmount(type, 0);
		if(amount > maxStorage)
			amount = maxStorage;
		this.storageAmount = amount;
		this.forceUpdate = true;
		this.markDirty();
		updateComparatorValuesPart2();
	}

	@Override
	public int getMaxStoredCount()
	{
		return maxStorage;
	}
	 */


	@Override
	public boolean hasCapability(Capability<?> capability, EnumFacing facing)
	{
		if((pos==4||pos==58) && capability==CapabilityItemHandler.ITEM_HANDLER_CAPABILITY)
			return true;
		//		if(pos>30&&pos<44 && pos%5>0&&pos%5<4 )
		//			return true;
		return super.hasCapability(capability, facing);
	}
	IItemHandler insertionHandler = new SiloInventoryHandler(this);
	@Override
	public <T> T getCapability(Capability<T> capability, EnumFacing facing)
	{
		if((pos==4||pos==58) && capability==CapabilityItemHandler.ITEM_HANDLER_CAPABILITY)
			return (T)insertionHandler;
		return super.getCapability(capability, facing);
	}

	public static class SiloInventoryHandler implements IItemHandlerModifiable
	{
		TileEntitySilo silo;
		public SiloInventoryHandler(TileEntitySilo silo)
		{
			this.silo = silo;
		}

		@Override
		public int getSlots()
		{
			return 2;
		}
		@Override
		public ItemStack getStackInSlot(int slot)
		{
			return slot==0?Utils.copyStackWithAmount(silo.identStack,Math.min(silo.storageAmount,1)):Utils.copyStackWithAmount(silo.identStack,Math.min(silo.storageAmount,64));
		}

		@Override
		public ItemStack insertItem(int slot, ItemStack stack, boolean simulate)
		{
			stack = stack.func_77946_l();
			TileEntitySilo silo = this.silo.master();
			int space = maxStorage-silo.storageAmount;
			if(slot!=0 || space<1 || stack==null || (silo.identStack!=null && !ItemHandlerHelper.canItemStacksStack(silo.identStack,stack)))
				return stack;
			int accepted = Math.min(space, stack.field_77994_a);
			if(!simulate)
			{
				silo.updateComparatorValuesPart1();
				silo.storageAmount += accepted;
				if(silo.identStack==null)
					silo.identStack = stack.func_77946_l();
				silo.func_70296_d();
				silo.markContainingBlockForUpdate(null);
				silo.updateComparatorValuesPart2();
			}
			stack.field_77994_a -= accepted;
			if(stack.field_77994_a<1)
				stack = null;
			return stack;
		}

		@Override
		public ItemStack extractItem(int slot, int amount, boolean simulate)
		{
			TileEntitySilo silo = this.silo.master();
			if(slot!=1 || silo.storageAmount<1 || amount<1 || silo.identStack==null)
				return null;
			ItemStack out;
			if(silo.identStack.field_77994_a>amount)
				out = Utils.copyStackWithAmount(silo.identStack, amount);
			else
				out = silo.identStack.func_77946_l();
			if(!simulate)
			{
				silo.updateComparatorValuesPart1();
				silo.storageAmount -= out.field_77994_a;
				if(silo.storageAmount<=0 && !silo.lockItem)
					silo.identStack = null;
				silo.func_70296_d();
				silo.markContainingBlockForUpdate(null);
				silo.updateComparatorValuesPart2();
			}
			return out;
		}
		@Override
		public void setStackInSlot(int slot, ItemStack stack)
		{
		}
	}

	@Override
	public int getComparatorInputOverride()
	{
		if(pos==4)
			return (15*storageAmount)/maxStorage;
		TileEntitySilo master = master();
		if (offset[1]>=1&&offset[1]<=6&&master!=null) //6 layers of storage
		{
			int layer = offset[1]-1;
			int vol = maxStorage/6;
			int filled = master.storageAmount-layer*vol;
			int ret = Math.min(15, Math.max(0, (15*filled)/vol));
			return ret;
		}
		return 0;
	}
	private void updateComparatorValuesPart1()
	{
		int vol = maxStorage / 6;
		for(int i=0; i<6; i++)
		{
			int filled = storageAmount - i * vol;
			oldComps[i] = Math.min(15, Math.max((15*filled)/vol, 0));
		}
		masterCompOld = (15*storageAmount)/maxStorage;
	}
	private void updateComparatorValuesPart2()
	{
		int vol = maxStorage / 6;
		if((15*storageAmount)/maxStorage!=masterCompOld)
			field_145850_b.func_175685_c(func_174877_v(), func_145838_q());
		for(int i=0; i<6; i++)
		{
			int filled = storageAmount - i * vol;
			int now = Math.min(15, Math.max((15*filled)/vol, 0));
			if(now!=oldComps[i])
			{
				for(int x=-1; x<=1; x++)
					for(int z=-1; z<=1; z++)
					{
						BlockPos pos = func_174877_v().func_177982_a(-offset[0]+x, -offset[1]+i+1, -offset[2]+z);
						field_145850_b.func_175685_c(pos, field_145850_b.func_180495_p(pos).func_177230_c());
					}
			}
		}
	}
}
